import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { HttpModule } from '@angular/http';
import { MaterialModule } from '@angular/material';
import { AgGridModule } from 'ag-grid-ng2/main';

// Services
import { BusStopCreateService } from './services/busstopcreate.service';
import { BooleanSelectListService } from './services/booleanselectlist.service';
import { BusStopService } from './components/grid/busStop.service';

import { EditorComponent } from './helpers/editor.component';
import { RendererComponent } from './helpers/renderer.component';
import { RichGridComponent } from './components/grid/rich-grid.component';

import 'hammerjs';

import { AppComponent } from './components/app/app.component';

@NgModule({
  declarations: [
    AppComponent,
    RichGridComponent,
    EditorComponent,
    RendererComponent
  ],
  imports: [
    RouterModule.forRoot([
      { path: 'grid', component: RichGridComponent }
    ]),
    BrowserModule,
    FormsModule,
    HttpModule,
    MaterialModule.forRoot(),
    AgGridModule.withComponents([
      RichGridComponent,
      EditorComponent,
      RendererComponent,
    ])
  ],
  providers: [
    BusStopCreateService,
    BooleanSelectListService,
    BusStopService
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
